<?php
/**
 * ------------------------------------------------------------------------
 * JA Image Hotspot Module for Joomla 2.5 & 3.4
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2016 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites: http://www.joomlart.com - http://www.joomlancers.com
 * ------------------------------------------------------------------------
 */

defined('_JEXEC') or die('Restricted access');

$app = JFactory::getApplication();
$doc = JFactory::getDocument();
$lang = jFactory::getLanguage();
$basepath = JURI::root(true).'/modules/' . $module->module . '/assets/';
//$description =$params->get('description');
jimport('joomla.filesystem.file');


//Load library jquery
require_once(dirname(__FILE__).'/behavior.php');
JHTML::_('JABehavior.jquery');

if(!defined('T3')){
    //Load popover and dropdown library
    $doc->addScript($basepath.'js/bootstrap-tooltip.js?v=1');
    $doc->addScript($basepath.'js/bootstrap-popover.js?v=1');
}
if (!defined('_MODE_JAIMAGESHOSTSPOT_')) {
    define('_MODE_JAIMAGESHOSTSPOT_', 1);
    $doc->addScript($basepath.'js/modernizr.custom.63321.js');

    if($lang->isRTL() == 1){
        $doc->addScript($basepath.'js/jquery.dropdown.rtl.js');
    }else{
        $doc->addScript($basepath.'js/jquery.dropdown.js');
    }
    $doc->addStyleSheet($basepath.'css/style.css?v=1');
    if(version_compare(JVERSION, '3.0', 'lt')) {
        $doc->addStyleSheet($basepath.'css/style_nonbs.css');
    }
    if($lang->isRTL() == 1){
        $doc->addStyleSheet($basepath.'css/style.rtl.css');
    }
    //load override css
    $templatepath = 'templates/'.$app->getTemplate().'/css/'.$module->module.'.css';
    if(file_exists(JPATH_SITE . '/' . $templatepath)) {
        $doc->addStyleSheet(JURI::root(true).'/'.$templatepath);
    }

    $doc->addStyleSheet($basepath.'elements/popover/jquery.webui-popover.css');
    $doc->addScript($basepath.'elements/popover/jquery.webui-popover.js');
}

$displaytooltips = $params->get('displaytooltips',1); // still keep number to compatiable with old version.
$multiple = $params->get('displaymultiple', 0);
$mobileLinkIcon = $params->get('mobileLinkIcon', 'window');

// hammer zoom js for mobile
$hammerjs = '';
$activeZFM = $params->get('ActiveZoomForMobile', 0); // default is disabled
// activeZ2CFD => active double click zoom for desktop. depend on zooming mobile function.
$activeZ2CFD = $params->get('Active2ClickZoomForDesktop', 0); // default is disabled
$maxZoom = $params->get('maxZoom', 2);

if ($activeZFM) {
    $doc->addScript($basepath.'js/hammer.min.js');
    $doc->addScript($basepath.'js/jquery.hammer.js');
    $hammerjs = "addHammerJS ('ja-imagesmap".$module->id."', ".$maxZoom.", ".$activeZ2CFD.");";
}

$trigger = 'hover';
if ($displaytooltips == 1)
	$trigger = 'sticky';
if ($displaytooltips == 2)
	$trigger = 'click';
$hidedelay = (int) $params->get('hidedelay', 2000);

$animation = $params->get('animation', 'pop');
$data = array();
foreach ($description AS $k => $v) {
	$data[$v->imgid] = $v;
}

$menuID = $app->getMenu()->getActive()->id;
$data = json_encode($data);
//escape special characters
$data = preg_replace("/(\\\\(n|r|t)|')/", '\\\\$1', $data);
$data = str_replace('\"', '\\\"', $data);

if (strpos($imgpath, '#joomlaImage://') == true){
    $imgpath = explode('#joomlaImage://', $imgpath)[0];
}else{
    $IMGsize = getimagesize($imgpath);
}
$script = "
var rootURL = \"".JUri::root(true)."/\";
var menuID = ".$menuID.";
var jadir = jQuery('html').attr('dir');
var pinchDuration = 0;

    ;(function($) {
    	// seperate pointer config.
    	var desc = $.parseJSON('".$data."');
    	// all pointer config.
    	var jaihp_settings = {
			hideDelay: ".$hidedelay.",
			trigger: '".$trigger."',
			multiple: ".$multiple.",
			anim: '".$animation."'
		};

		$(window).on('load', function() {
		    scaleIconFollowScreen('ja-hotspot-image-".$module->id."', 'ja-imagesmap".$module->id."');
		    ".$hammerjs."
			// Remove Chosen Select.
			if ($('#ja-imagesmap".$module->id." #cd-dropdown').hasClass('chzn-done'))
				$('#ja-imagesmap".$module->id." #cd-dropdown').chosen('destroy');
			$('#ja-imagesmap".$module->id." #cd-dropdown').jadropdown({
                gutter : 0,
                stack : false
            });

			$('#ja-imagesmap".$module->id." .cd-dropdown ul li').click(function() {
				target = $(this).attr('data-value');
                setTimeout(function() {
                    WebuiPopovers.show('#ja-imagesmap".$module->id." #'+target+' .bg');
                }, 100);
			});

			$('#ja-imagesmap".$module->id." a.point').each(function() {
				var data = desc[$(this).attr('id').replace('ja-marker-','')];
				var _e = $(this).find('.bg');
				// around here little messy. we should clean up a bit in future
				// this only work on mobile + popup type = window + type = website.
				if ('".$mobileLinkIcon."' == 'window' 
				    && is_mobile_device()
				    && data.content_url
				    && data.content_type == 'website'
				    ) {
                    _e.click(function(event) {
                        window.open($(this).parent().data('content_url'), '_blank');
                        return false;
                        event.preventDefault();
                        return false;
                    });
				} else // normal function.
				    OverAllData(_e, data, jaihp_settings);

				if (jaihp_settings.trigger == 'hover' && !is_mobile_device()) {
					// add click to the url if not click event.
					_e.click(function(event) {
						if ($(this).parent().data('link') && data.content_type == 'default') {
							window.open($(this).parent().data('link'), '_blank');
							return;
						}
						if ($(this).parent().data('content_url'))
							window.open($(this).parent().data('content_url'), '_blank');
						event.preventDefault();
						return false;
					});
				}
				if (jaihp_settings.trigger == 'sticky') {
					_e.off().unbind().click(function(event) {
						_e.webuiPopover('destroy');
						_e.off().unbind();
						jaihp_settings2=jaihp_settings;
						jaihp_settings2.trigger='hover';
						OverAllData(_e, data, jaihp_settings2);
						event.preventDefault();
						return false;
					});
				}
			});
            jQuery(window).on('resize', function(event) {
                scaleIconFollowScreen('ja-hotspot-image-".$module->id."', 'ja-imagesmap".$module->id."');
            });
		});
	 })(jQuery);";

$doc->addScriptDeclaration($script);
$doc->addScript($basepath.'js/script.js');